Summary:        NDE file manager NDEFileMAN
Name:           nde-fileman 
Version:        0.0.1
Release:        114%{?dist}
License:		GPLv2+
URL:            http://www.gd-linux.com
Source0:        %{name}-%{version}.tar.gz
# using libfm-qt-nde instead of libfm-qt
Patch5000:		nde-fileman-using-libfm-qt-nde.patch
BuildRequires:  cmake, gcc-c++, doxygen, nde-lib-devel
BuildRequires:  qt5-qttools-devel, qt5-qtx11extras-devel, libX11-devel, libxcb-devel
BuildRequires:  glib2-devel, libfm-devel, menu-cache-devel, exiv2-devel
BuildRequires:  libfm-qt-nde-devel, desktop-file-utils, kf5-kwindowsystem-devel, libexif-devel
Requires:       file-roller
Requires:       p7zip
Recommends:     gvfs
Recommends:     nde-terminal



%description
%{summary}

%package l10n
Summary:        Translations for nde-fileman
Requires:       nde-fileman

%description l10n
This package provides translations for the nde-fileman package.



%prep
%autosetup -p1



%build
mkdir -p %{_target_platform}
pushd %{_target_platform}
	%{cmake_nde} -DBUILD_DOCUMENTATION=ON -DPULL_TRANSLATIONS=NO ..
popd

make %{?_smp_mflags} -C %{_target_platform}



%install
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}

%find_lang nde-fileman --with-qt



%post
/usr/bin/update-desktop-database &> /dev/null || :
# sudo免密码
chmod 660 /etc/sudoers
sed -i 's/# %wheel/%wheel/' /etc/sudoers
chmod 440 /etc/sudoers

# 修复壁纸变黑色及默认桌面图标消失的问题
if [ "$1" = "2" ]; then
        userHomes=$(ls -l /home/ | awk '/^d/ {print $NF}')
	for user in $userHomes
	do
		SETTINGS_FILE="/home/$user/.config/nde-fileman/nde/settings.conf"
		if [ -f $SETTINGS_FILE ]; then
			wallpaper=`grep "Wallpaper=" $SETTINGS_FILE`
			wallpaperpath=${wallpaper#*=}
			echo $wallpaperpath
			if [ "$wallpaperpath" = "" ]; then
				sed -i 's/Wallpaper=/Wallpaper=\/usr\/share\/backgrounds\/default.png/g' $SETTINGS_FILE
			fi

			if [ `grep -c "WallpaperMode=none" $SETTINGS_FILE` -eq "1" ]; then
				sed -i 's/WallpaperMode=none/WallpaperMode=stretch/g' $SETTINGS_FILE
			fi

			if [ `grep -c "DesktopShortcuts" $SETTINGS_FILE` -eq "0" ]; then
				sed -i '/DesktopIconSize=48/a\DesktopShortcuts=Home, Trash, Computer' $SETTINGS_FILE
			else
				DesktopShortcuts=`grep "DesktopShortcuts" $SETTINGS_FILE`
				ShortcutsValue=${DesktopShortcuts#*=}
				if [ "$ShortcutsValue" = "@Invalid()" ]; then
					sed -i 's/DesktopShortcuts=@Invalid()/DesktopShortcuts=Home, Trash, Computer/g' $SETTINGS_FILE
				fi
			fi
		fi
	done
fi

%postun
/usr/bin/update-desktop-database &> /dev/null || :



%files
%license LICENSE
%doc AUTHORS CHANGELOG README.md
%{_bindir}/nde-fileman
%{_datadir}/applications/%{name}.desktop
%{_datadir}/applications/%{name}-desktop-pref.desktop
%{_docdir}/nde-fileman
%{_mandir}/man1/nde-fileman.*
%{_sysconfdir}/xdg/autostart/nde-desktop.desktop
%{_datadir}/nde-fileman/nde/settings.conf
%{_datadir}/nde-fileman/nde/notsupporroot.list
%{_datadir}/%{name}

%files l10n -f nde-fileman.lang
%license LICENSE
%doc AUTHORS CHANGELOG README.md
%dir %{_datadir}/%{name}/translations



%changelog
* Tue Jan 30 2024 Zhao Zhen <jeremiazhao@tencent.com> - 0.0.1-114
- small fix

* Sat Nov 21 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-113
- 文件管理器标签栏样式修改(1253)

* Tue Nov 17 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-112
- 修复双屏情况下改变分辨率桌面图标无法自适应问题
- 修复双屏情况下新建删除桌面文件导致副屏图标回到主屏问题

* Thu Nov 12 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-111
- 修复双屏下桌面图标被遮挡问题(#2952)

* Fri Nov 06 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-109
- 新建本地磁盘不弹窗

* Wed Nov 04 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-108
- 修复计算机页面以“图标视图”展示，但视图按钮显示为“缩略图视图”问题(#2933)

* Tue Nov 03 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-107
- 修复插入存储设备识别问题

* Mon Nov 02 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-106
- 修复屏蔽ZTE云桌面或者虚拟机的分辨率设置入口的bug

* Fri Oct 30 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-105
- 目录检索快捷键无法使用的问题

* Thu Oct 29 2020 He Leilei <he.leilei@zte.com.cn> - 0.0.1-104
- 修改右键菜单样式

* Mon Oct 26 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-103
- 更改控制中心配置文件为/etc/nde/nde.conf文件

* Fri Oct 23 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-102
- 文件管理器详细视图表头默认不显示用户和组
- 文件管理器详细视图表头名称列默认宽度300px

* Wed Oct 21 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-101
- 修复检索结果快捷键操作失效的问题

* Wed Oct 21 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-100
- 回退文件管理器默认打开计算机目录和主目录中文件小于12则以视图模式显示功能

* Tue Oct 20 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-99
- 切换目录后清空检索框
- 选中检索结果第一个结果
- 异常关闭窗口以标签方式打开

* Mon Oct 19 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-98
- 标签栏添加“在新标签页打开”按钮

* Thu Oct 15 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-97
- 文件管理器默认打开计算机目录和主目录中文件小于12则以视图模式显示，否则以详细详细模式显示

* Wed Oct 14 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-96
- 文件管理器主目录默认视图模式打开(1204)
- 文件管理器主菜单添加显示隐藏文件功能(1195)

* Tue Oct 13 2020 wu jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-95
- 远程连接Bug

* Mon Oct 12 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-94
- 增加恢复异常退出文件管理器功能

* Mon Oct 12 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-93
- 修复文件管理器右键查看保存所选的模式

* Fri Oct 09 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-92
- 收藏夹打开方式以新窗口打开
- 增加文件管理器当前目录检索功能

* Fri Oct 09 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-91
- 屏蔽ZTE云桌面和虚拟机在桌面上的监视器设置入口

* Tue Sep 29 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-90
- 固定系统默认图标(#2868)

* Fri Sep 25 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-89
- 修复文件管理器右键改变视图无法保存视图模式问题(#2845)

* Tue Sep 22 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-88
- 修改文件管理器默认详细信息显示

* Mon Sep 21 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-87
- 修复分辨率缩小后桌面图标被遮住的问题

* Mon Sep 21 2020 lv kaiyi <lv.kaiyi@zte.com.cn>- 0.0.1-86
- 修复搜索框删除掉字符之后焦点不正确问题

* Fri Sep 18 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-84
- 修复桌面任务栏改变位置导致桌面图标重排序问题(#2482)
- 修复自动排序下分辨率改变，图标重排序问题(#2817)
- 修复桌面同一种排序不能再次点击问题（#2671）

* Thu Sep 17 2020 lv kaiyi <lv.kaiyi@zte.com.cn>- 0.0.1-84
- 修复搜索结果显示数量不正确到问题 

* Mon Sep 14 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-83
- 修复桌面自动排序下重命名文件图标会被覆盖问题

* Wed Sep 09 2020 wu jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-82
- 添加汉化

* Wed Sep 09 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-81
- 删除压缩软件p7zip依赖，解决压缩中文乱码问题

* Mon Sep 07 2020 Wu Jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-80
- 重新实现桌面图标自动排序功能

* Mon Sep 07 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-79
- 删除菜单栏书签功能

* Mon Sep 07 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-78
- 文件管理器收藏夹功能

* Wed Sep 02 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-77
- 处理显示搜索结果后搜索框聚焦问题

* Tue Sep 01 2020 Wu Jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-76
- 先排序三个主图标位置

* Mon Aug 31 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-75
- 修复桌面排序，主界面图标移位问题(#2769)
- 屏蔽桌面默认应用的重命名功能

* Thu Aug 27 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-74
- 屏蔽桌面文件夹右键菜单中的“在新标签页打开”和“在新窗口打开”功能(#2712)

* Wed Aug 26 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-73
- 修复拖动桌面图标至其它图标处会一直往下推着走的问题(#2443)

* Wed Aug 26 2020 Wu Jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-72
- 分辨率改变时刷新桌面

* Tue Aug 25 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-71
- 搜索功能递归搜索所有子目录的问题

* Mon Aug 24 2020 Wu Jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-70
- 去掉桌面隐藏项目，添加自动排序

* Fri Aug 21 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-69
- 修复中文文件或文件夹创建快捷方式乱码问题

* Fri Aug 21 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-68
- 添加磁盘右键菜单“在新标签打开”和“在新窗口打开”功能(#2638)

* Thu Aug 20 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-67
- desktop的快捷方式改为复制模式
- 桌面添加F5刷新功能

* Thu Aug 20 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-66
- 改变目录路径后，搜索框清空

* Tue Aug 18 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-65
- 修改快捷方式命名格式
- 修复桌面右键多个应用问题(#2650)

* Thu Aug 13 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-64
- 修复创建快捷方式中文乱码问题

* Thu Aug 13 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-63
- 打开多个标签页时关闭窗口弹出提示框
- 修复文件文件管理器打开多个窗口，在任务栏关闭出现崩溃问题
- 优化创建快捷方式功能，添加创建快捷方式到桌面功能
- 优化重命名功能

* Thu Aug 13 2020 wu jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-62
- 远程连接错误弹出两次bug

* Mon Aug 10 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-61
- 模式菜单提示翻译
- 我的电脑显示视图模式问题

* Mon Aug 10 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-60
- 修改多选时的右键菜单功能
- 修改桌面默认应用在文件管理器下的右键菜单功能
- 禁止桌面默认应用被拖到回收站

* Tue Aug 04 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-58
- 固定断开远程链接配置，不关闭文件管理器

* Tue Aug 04 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-57
- 修复文件管理器最大化后打开里面的文件夹导致窗口变小问题(#2511)

* Tue Aug 04 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-56
- 修改默认断开远程操作配置

* Tue Aug 04 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-55
- 修复无法关闭选中标签页问题(#2509)

* Fri Jul 31 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-54
- 屏蔽回收站、计算机中右键菜单的部分无用功能
- 标签页右键菜单添加“关闭标签”功能

* Fri Jul 31 2020 wu jiaheng <wu.jiaheng@zte.com.cn> - 0.0.1-53
- 远程连接历史记录

* Thu Jul 30 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-52
- 打开文件管理器显示置顶

* Tue Jul 28 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-51
- 右键菜单功能顺序调整

* Mon Jul 27 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-50
- 修改右键菜单背景为白色
- 接收文件管理器按钮地址栏右键菜单“在新标签打开”与“在新窗口打开“信号
- 文件管理器标签右键菜单添加”新建标签页“功能

* Mon Jul 27 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-49
- 文件管理器打开窗口显示位置

* Thu Jul 23 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-48
- 修复桌面多出一个文件问题(#2286)
- 替换文件管理器搜索框的右键菜单

* Mon Jul 20 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-47
- 修复回收站右键图标闪退问题
- “垃圾桶”改为“回收站”

* Thu Jul 16 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-46
- 调整视图显示方式，状态栏显示样式

* Wed Jul 15 2020 He Leilei <he.leilei@zte.com.cn> - 0.0.1-45
- 修改桌面设置在设置中心中的分组位置

* Tue Jul 14 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-44
- 文件夹右键菜单中的“粘贴”无三态问题(#2329)

* Tue Jul 14 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-43
- 修复桌面右键菜单排序图标的显示

* Tue Jul 14 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-42
- 添加文件夹右键菜单“在新标签打开”和“在新窗口打开”功能(#2313)

* Mon Jul 13 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-41
- 替换桌面右键菜单排序和查看选中图标

* Fri Jul 10 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-40
- 添加右键菜单小图标
- 右键菜单“粘贴”功能具备三种形态(#2278)

* Fri Jul 10 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-39
- 去除桌面右键菜单“查看”功能中的图标大小设置功能

* Wed Jul 08 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-38
- 回收站具备显示非空状态功能(1083)

* Tue Jul 07 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-37
- 修复桌面默认图标右键菜单问题(#2248)(#2249)

* Mon Jul 06 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-36
- 添加右键子菜单阴影

* Mon Jul 06 2020 Zhou Tuan <zhou.tuan@zte.com.cn> - 0.0.1-35
- 修复新建分区无法自动挂载的问题

* Fri Jul 03 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-34
- 修改右键子菜单样式

* Fri Jul 03 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-33
- 添加回收站右键中“清空回收站”功能(#2248)

* Fri Jul 03 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-32
- 我的电脑视图模式的问题

* Fri Jul 03 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-31
- 修复右键打开个性化后无法使用右键问题(#2240)

* Thu Jul 02 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-30
- 屏蔽桌面右键菜单中的文件管理器的“查看”功能

* Thu Jul 02 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-29
- 添加桌面右键菜单的"查看"功能和文件管理器查看功能的信号接收

* Thu Jul 02 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-28
- 修改文件管理器与桌面样式

* Wed Jul 01 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-27
- 实现桌面排序功能与文件管理器的排序区别开

* Tue Jun 30 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-26
- 添加rarlinux依赖包，实现.rar和.cbr格式压缩功能

* Tue Jun 30 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-25
- 修改文件管理器保存之前显示模式

* Mon Jun 29 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-24
- 对每个用户进行修复壁纸变黑色及默认桌面图标消失的问题

* Mon Jun 29 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-23
- 修复壁纸变黑色及默认桌面图标消失的问题

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-22
- 在桌面图标列表末尾后生成新的图标

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-21
- 回退固定桌面图标座标

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-20
- 修改文件管理器右键菜单刷新功能

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-19
- 固定桌面图标座标
- 添加p7zip压缩插件

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-18
- 隐藏回收站右键菜单中的“创建”功能
- 添加root权限白名单

* Wed Jun 24 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-17
- 修改默认终端为ndeterminal

* Tue Jun 23 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-16
- 修改桌面文件管理器样式

* Tue Jun 23 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-15
- 修复升级默认打开终端不是ndeterminal问题
- 屏蔽右键“系统信息”功能
- 添加桌面右键菜单“显示设置”、“个性化”功能，屏蔽”桌面偏好设置“功能
- 隐藏桌面右键菜单“全选”，“反选”，“显示隐藏文件”功能

* Tue Jun 23 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-14
- 修改文件管理器滚动条样式

* Mon Jun 22 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.0.1-13
- 更新文件管理器版权声明

* Mon Jun 22 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-12
- 修改默认打开终端为ndeterminal
- 屏蔽右键文件夹的其他打开方式

* Fri Jun 19 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-11
- 修改文件管理器工具栏样式

* Thu Jun 18 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-10
- 添加右键图标“发送到”功能和桌面右键刷新功能

* Wed Jun 17 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-9
- 添加默认图标右键菜单功能(1007)

* Tue Jun 16 2020 lv kaiyi <lv.kaiyi@zte.com.cn> - 0.0.1-8
- 修改文件管理器磁盘、文件布局等

* Fri Jun 12 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-7
- 右键菜单添加：图标创建快捷方式、右键菜单打开终端、以管理员取权限运行应用功能

* Fri Jun 5 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.0.1-6
- 修改文件管理器工具栏侧边栏以及显示栏

* Thu Jun 4 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.0.1-5
- 默认字体思源黑体

* Mon Jun 01 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.0.1-4
- 更改应用名称

* Tue May 26 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.0.1-3
- 更改su-command，删除onlyshowin显示设置

* Tue May 26 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-2
- 修改默认桌面显示图标，只显示我的电脑、我的目录、回收站快捷键

* Fri May 15 2020 Wu Shangmin <wu.shangmin@zte.com.cn> - 0.0.1-1
- Rename(984)

* Tue Apr 28 2020 Zhang Wen <zhang.wen2@zte.com.cn> - 0.14.1-2.1
- 调整文件浏览器局部布局




